<template>
  <div v-if="loaded">
      <WeatherResult 
        :data="data"
        :sunrise="sunrise" 
        :sunset="sunset"
        :date="date"
      />
  </div>
  <div class="searchBar flex-c p-a">
    <label for="searchInput">Rechercher</label>
    <input v-on:keydown="refreshErrorMsg" v-on:keydown.enter="fetchData()" v-model="query" type="text" id="searchInput">
    <!-- <button type="button" v-on:click="fetchLocalizedData()">Cliquez-moi</button> --> 
    <div v-if="error">
      <p class="errorMsg">Impossible de trouver "{{ query }}"</p>
    </div>
  </div>
</template>

<script>
import WeatherResult from './WeatherResult'
import {unixToHourAndMinutes} from '../assets/functions'
import Axios from 'axios'

export default {
  name: 'Layout',
  components: {
      WeatherResult
  },
  data() {
    return {
      options: {
          units: 'metric',
          apiKey: 'b72b48d7b4350d69a0de154e63368365',
          lang: 'fr',
          position: {
            latitude: null,
            longitude: null
          }
      },
      query: null,
      apiUrl: null,
      loaded: false,
      data: {},
      date: null,
      error: false,
    };
  },
  methods: {
    async fetchData() {
      // FETCH
      await Axios
        .get(`https://api.openweathermap.org/data/2.5/weather?q=${this.query}&units=${this.options.units}&appid=${this.options.apiKey}&lang=${this.options.lang}`)
        // IF INPUT DOESN'T MATCH WITH API, SEND AN ERROR
        .catch(() => {
          this.error = true;
        })
        .then(response => {
          this.data = response.data;
          this.date = new Date().toLocaleDateString();
          this.loaded = true;
          this.sunrise = unixToHourAndMinutes(this.data.sys.sunrise);
          this.sunset = unixToHourAndMinutes(this.data.sys.sunset);
        });
        // CHANGE WIND DIRECTION
        document.getElementById('windDirectionIcon').style.transform = `rotate(${this.data.wind.deg}deg)`;
    },
    /*async fetchLocalizedData() {
      // GEOLOCATION SUCCESS
      const successCallback = (position) => {
        this.options.position.latitude = Math.round(position.coords.latitude * 100) / 100;
        this.options.position.longitude = Math.round(position.coords.longitude * 100) / 100;
        // URL WITH LATITUDE AND LONGITUDE
        this.apiUrl = `https://api.openweathermap.org/data/2.5/weather?lat=${this.options.position.latitude}&lon=${this.options.position.longitude}&units=${this.options.units}&appid=${this.options.apiKey}&lang=${this.options.lang}`;
      }
      // GEOLOCATION ERROR
      const errorCallback = (err) => {
        return err;
      }
      // GET CURRENT POSITION
      navigator.geolocation.getCurrentPosition(successCallback, errorCallback);
      
      // FETCH
      await Axios
        .get(this.apiUrl)
        // IF INPUT DOESN'T MATCH WITH API, SEND AN ERROR
        .catch(() => {
          this.error = true;
        })
        .then(response => {
          this.data = response.data;
          this.loaded = true;
          this.sunrise = unixToHourAndMinutes(this.data.sys.sunrise);
          this.sunset = unixToHourAndMinutes(this.data.sys.sunset);
        });
        // CHANGE WIND DIRECTION
        document.getElementById('windDirectionIcon').style.transform = `rotate(${this.data.wind.deg}deg)`;
    },
    refreshErrorMsg() {
      this.error = false;
    }*/
  },
}
</script>

<style scoped lang="scss">
  @import './Layout.scss';
</style>